Order Management Service (OMS) API Specs
REAVENTECH Bank Trader OMS API (1.8.2)
Download OpenAPI specification:Download
Welcome to the REAVENTECH Bank Trader OMS API. This api helps our clients to trade all instruments available for trading.
Reverse the execution
Authorizations:
path Parameters
| orderId required | string |
| executionId required | string |
Responses
Response samples
- 200
{- "id": "b94c32fa-af33-4ee2-a9cb-0f8738eb5671",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "internalOrderId": "a1a4701f-b4b0-4fd9-82d5-24a0b180d992",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "provider": "ICF",
- "executionId": "EXEC_ID_2023_01_24_843296",
- "executionReferenceId": "EXEC_ID_2023_01_24_843296",
- "executionType": "PENDING_NEW",
- "executionInstruction": "External Routing Not Allowed",
- "executionRestatementReason": 7,
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "secondaryOrderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "side": "BUY",
- "transactTime": "2023-01-28T13:58:43Z",
- "orderType": "MARKET",
- "orderStatus": "PENDING_NEW",
- "orderQty": 2,
- "price": 12.75,
- "stopPrice": 12.65,
- "currencyCode": "EUR",
- "lastMarket": "string",
- "lastQty": 0.1,
- "lastPrice": 0.1,
- "leavesQty": 0.1,
- "cumQty": 0.1,
- "averagePrice": 12.75,
- "settlementType": "REGULAR",
- "settlementDate": 20230125,
- "settlementCurrencyAmount": 238.65,
- "settlementCurrency": "EUR",
- "settlementCurrencyFxRate": 1.0893,
- "settlementCurrencyFxRateCalculation": "MULTIPLY",
- "regulatoryTradeID_TVTIC": "TVTIC",
- "text": "some comment",
- "returnCodeProvider": 1,
- "orderRejectReason": 1,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "commission": 3.25,
- "commissionInfo": "Commission: 3.25. Commission %: 1.00",
- "slippage": 0.25,
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "mifirTransactionId": "cf002f71d22f41348fb6ef54ab9c0840yyyyMMddHHmmss",
- "mifirReportedFlag": true,
- "mifirReportedFlagUpdateDate": "2023-01-25",
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "decisionMakerShortCode": "dmuser1",
- "investmentDecisionMakerShortCode": "dmuser1",
- "tradingCapacity": 1,
- "contraFirmLEI": "string",
- "contraFirmMIC": "XQTX",
- "reversedUserId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "reversedDate": "2023-01-28T13:58:43Z"
}Request order status
Authorizations:
Request Body schema: application/jsonrequired
| tradeRequestId required | string [ 1 .. 16 ] characters A unique identifier string of the reporting request of order order status. Assigned by caller of the API.Uniqueness must be guaranteed within your software. |
| clientOrderId required | string [ 1 .. 50 ] characters A unique identifier string of the order as assigned by caller of the API.Uniqueness must be guaranteed within your software. |
| orderId required | string Order Id assigned by the API after calling create order API endpoint.This is the assigned order Id when placing the order. |
| clientId required | string <uuid> [ 0 .. 36 ] characters Identifier UUID formatted string of the client for which the trading is done. If your API is an On-Premise deployment and your software uses the API in a server-to-server scenario, then, the API calling user is a Tenant user and has tenant_admin or api_user role. In this case, this is REQUIRED. If your API is a Main deployment and your software uses the API in a client-to-server scenario, and, the API calling user is a Business client user and has client_admin or client_brokerage_desk or api_user role. and the user wants to make a trade for its own client, in this case, this is REQUIRED. Otherwise, this should not be set. |
| marketAccountId | string NOTE: Filter not used for now. Account mnemonic as agreed between buy and sell sides, e.g. broker and institution or investor/intermediary and fund manager. Not required unless you are provided for a specific market account Id. |
| side required | string Enum: "BUY" "SELL" "BUYMINUS" "SELLPLUS" "SELLSHORT" "SELLSHORTEXEMPT" "UNDISCLOSED" "CROSS" "CROSSSHORT" "CROSSSHORTEXEMPT" "ASDEFINED" "OPPOSITE" Order side that is to be requested for status report. |
| isinCode required | string = 12 characters ISIN of the financial instrument to be traded. |
| tradeDateBegin | string <YYYYMMDD HHmmss> Order trade date begin optional filter. If not provided 24 hours previous day of 00:00:00 is used |
| tradeDateEnd | string <YYYYMMDD HHmmss> Order trade date begin optional filter. If not provided 24 hours later daye fo current date of 23:59:59 is used |
| orderType | string Enum: "MARKET" "LIMIT" "STOP" "STOP_LIMIT" "PREVIOUSLY_QUOTED" Order type optional filter. NOTE: Filter not used for now. |
| orderStatus | string Enum: "WAITING_SEND_CREATE_MSG" "WAITING_SEND_CANCEL_MSG" "WAITING_SEND_MODIFY_MSG" "PENDING_PARTIAL_FILL" "PENDING_FILL" "NEW" "PARTIALLY_FILLED" "FILLED" "CANCELED" "PENDING_CANCEL" "DELETED" "REJECTED" "SUSPENDED" "PENDING_NEW" "WAITING_FOR_EVENT" "EXPIRED" "PENDING_REPLACE" Order status optional filter. NOTE: Filter not used for now. |
| price | number <decimal(14, 2)> Price Optional filter for execution limit of order. NOTE: Filter not used for now. |
| expireDate | string <YYYYMMDD> [ 0 .. 8 ] characters ExpireDate optional filter for date of order expiration. NOTE: Filter not used for now. |
| text | string [ 0 .. 2048 ] characters A text for comment/note for your later reference |
Responses
Request samples
- Payload
{- "tradeRequestId": "a UUID may be",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "marketAccountId": "BUY",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "tradeDateBegin": 20230128,
- "tradeDateEnd": 20230128,
- "orderType": "MARKET",
- "orderStatus": "PENDING_NEW",
- "price": 12.75,
- "expireDate": 20230128,
- "text": "some comment"
}Response samples
- 200
{- "id": "REQUESTED",
- "status": "REQUESTED",
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "provider": "ICF",
- "sourcePlatform": "REST_API",
- "exDestination": "XQTX",
- "tradeRequestId": "a UUID may be",
- "tradeRequestType": 1,
- "totalNumberOfTradeReports": 1,
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "marketAccountId": "BUY",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "tradeDateBegin": 20230128,
- "tradeDateEnd": 20230128,
- "orderType": "MARKET",
- "orderStatus": "PENDING_NEW",
- "price": 12.75,
- "expireDate": 20230128,
- "text": "some comment",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string"
}Modify order
Authorizations:
Request Body schema: application/jsonrequired
| clientOrderId required | string [ 1 .. 50 ] characters A unique identifier string of the order as assigned by caller of the API.Uniqueness must be guaranteed within your software. |
| orderId required | string [ 1 .. 50 ] characters Order Id assigned by the API after calling create order API endpoint.This is the assigned order Id when placing the order. |
| clientId required | string <uuid> = 36 characters The Identifier UUID formatted string of Client that owns this order. |
| isinCode required | string = 12 characters ISIN of the financial instrument to be traded. |
| newPrice | number <decimal(14, 2)> Default: "0.0" Price per unit of quantity, mandatory value when orderType is one of "LIMIT" or "STOP_LIMIT"Set as default 0.0 otherwise |
| newStopPrice | number <decimal(14, 2)> Default: "0.0" Stop price per unit of quantity, mandatory value when orderType is one of "STOP" or "STOP_LIMIT"Set as default 0.0 otherwise |
| newOrderQty | number <decimal(14, 2)> Default: "0.0" Trade volume / quantity.Used if orderSubType is "REGULAR" or "FRACTIONAL" only. Set Zero otherwise. The orderQty is calculated within the API based on the market price. |
| newOrderAmount | number <decimal(14, 2)> Default: "0.0" Used if orderSubType is "MONEY_ORDER" only. Set Zero otherwise.Contains total money amount of desired investment. The orderQty is calculated within the API based on the market price. |
| newTimeInForce required | string Enum: "DAY" "GOOD_TILL_CANCEL" "IMMEDIATE_OR_CANCEL" "FILL_OR_KILL" "GOOD_TILL_DATE" It specifies a time frame for the order to be valid. Only IMMEDIATE_OR_CANCEL, FILL_OR_KILL, GOOD_TILL_DATE supported. IMMEDIATE_OR_CANCEL: The order is valid until if it can be FILLED within a few seconds. Then it will be CANCELED by the market and will not be processed. FILL_OR_KILL: The order is valid until it can be FILLED fully. If not, it will be CANCELED by the market and will not be processed. GOOD_TILL_DATE: The order is valid until the day you specified in expireDate. NOTE: Even if this value is not modified, this ust always be given. |
| newExpireDate | string <YYYYMMDD> = 10 characters Date of order expiration (the local market date at which the order can be traded last). Must always be given (independent of timeInForce)NOTE: Even if this value is not modified, this ust always be given. |
| algorithmIdentifier | string <([A-Z]|[0-9]){1,50}> [ 0 .. 50 ] characters If this cancel order request is generated by an automated trading algorithm of a client then this field should be set to NON-NULL. If not by an algorithm, provide null. Format is ESMA_AlphaNumericCapitalLettersMax50_Pattern which is defined as follows: (ie: Max 50, English capital letters A-Z and numbers 0-9); |
| investmentDecisionMakerId | string <uuid> = 36 characters Identifier UUID of decision maker. |
| executingTraderId | string <uuid> = 36 characters Identifier UUID of executing trader. |
Responses
Request samples
- Payload
{- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "isinCode": "AT0000609607",
- "newPrice": 12.75,
- "newStopPrice": 12.65,
- "newOrderQty": 2,
- "newOrderAmount": 350,
- "newTimeInForce": "FILL_OR_KILL",
- "newExpireDate": 20230128,
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "executingTraderId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72"
}Response samples
- 200
{- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "isinCode": "AT0000609607",
- "newPrice": 12.75,
- "newStopPrice": 12.65,
- "newOrderQty": 2,
- "newOrderAmount": 350,
- "newTimeInForce": "FILL_OR_KILL",
- "newExpireDate": 20230128,
- "provider": "ICF",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "currencyCode": "EUR",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "initialQty": 0,
- "marketQty": 0,
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "transactTime": "2023-01-28T13:58:43Z",
- "side": "BUY",
- "price": 12.75,
- "stopPrice": 12.65,
- "orderQty": 2,
- "orderAmount": 350,
- "orderStatus": "PENDING_NEW",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "blockOrderType": "NONE",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient"
}Cancel order
Authorizations:
Request Body schema: application/jsonrequired
| clientOrderId required | string [ 1 .. 50 ] characters A unique identifier string of the order as assigned by caller of the API.Uniqueness must be guaranteed within your software. |
| orderId required | string [ 1 .. 50 ] characters Order Id assigned by the API after calling create order API endpoint.This is the assigned order Id when placing the order. |
| clientId required | string <uuid> [ 0 .. 36 ] characters Identifier UUID formatted string of the client for which the trading is done. If your API is an On-Premise deployment and your software uses the API in a server-to-server scenario, then, the API calling user is a Tenant user and has tenant_admin or api_user role. In this case, this is REQUIRED. If your API is a Main deployment and your software uses the API in a client-to-server scenario, and, the API calling user is a Business client user and has client_admin or client_brokerage_desk or api_user role. and the user wants to make a trade for its own client, in this case, this is REQUIRED. Otherwise, this should not be set. |
| orderType required | string Enum: "MARKET" "LIMIT" "STOP" "STOP_LIMIT" "PREVIOUSLY_QUOTED" Order type of the order to be canceled. |
| side required | string Enum: "BUY" "SELL" "BUYMINUS" "SELLPLUS" "SELLSHORT" "SELLSHORTEXEMPT" "UNDISCLOSED" "CROSS" "CROSSSHORT" "CROSSSHORTEXEMPT" "ASDEFINED" "OPPOSITE" Order side. Only 'BUY', 'SELL' supported. |
| isinCode required | string = 12 characters ISIN of the financial instrument to be traded. |
| orderQty required | number <decimal(14, 2)> Trade volume / quantity.Used if orderSubType is "REGULAR" or "FRACTIONAL" only. Set Zero otherwise. The orderQty is calculated within the API based on the market price. |
| cancelReason required | integer <int32> Default: 1 Cancel reason by the caller.Set 1 = Cancel by kill |
| transactTime | string <YYYYMMDD-HH:MM:SS.ssssss> Date and time of execution. |
| algorithmIdentifier | string <([A-Z]|[0-9]){1,50}> [ 0 .. 50 ] characters If this cancel order request is generated by an automated trading algorithm of a client then this field should be set to NON-NULL. If not by an algorithm, provide null. Format is ESMA_AlphaNumericCapitalLettersMax50_Pattern which is defined as follows: (ie: Max 50, English capital letters A-Z and numbers 0-9); |
| investmentDecisionMakerId | string <uuid> = 36 characters Identifier UUID of decision maker. |
| executingTraderId | string <uuid> = 36 characters Identifier UUID of executing trader. |
Responses
Request samples
- Payload
{- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "orderType": "MARKET",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "orderQty": 2,
- "cancelReason": 1,
- "transactTime": "20230120-15:30:25",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "executingTraderId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72"
}Response samples
- 200
{- "id": "27b03c8d-cd46-454e-8c15-42eea0f82d11",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "internalOrderId": "a1a4701f-b4b0-4fd9-82d5-24a0b180d992",
- "provider": "ICF",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "orderQty": 2,
- "cancelReason": 1,
- "transactTime": "2023-01-28T13:58:43Z",
- "orderType": "MARKET",
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "cancelRejectedByProvider": true,
- "cancelRejectionDate": "2023-01-28T13:58:43Z",
- "cancelRejectResponseTo": 1,
- "cancelRejectReason": 0,
- "orderStatusAtCancelReject": "PENDING_NEW",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient"
}Get latest status of the given orders
Returns the latest status of the given order ids or client order ids.Max number of order ids per query is 250.
Authorizations:
Request Body schema: application/jsonrequired
Responses
Request samples
- Payload
[- "string"
]Response samples
- 200
[- {
- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderStatus": "PENDING_NEW",
- "updatedDate": "2023-01-28T13:58:43Z"
}
]Create order (Place an order)
Authorizations:
query Parameters
| riskClassConsent | boolean Example: riskClassConsent=true Consent for the incompitable risk class order. |
Request Body schema: application/jsonrequired
| orderType required | string Enum: "MARKET" "LIMIT" "STOP" "STOP_LIMIT" "PREVIOUSLY_QUOTED" Order type. Only 'MARKET', 'LIMIT', 'STOP', 'STOP_LIMIT' supported.For OrderSubType = 'MONEY', only 'MARKET' must be set.For OrderSubType = 'FRACTIONAL', only 'MARKET' must be set.If MARKET is chosen, then “price” and “stopPrice” should be zero, because they are ignored anyway. If LIMIT is chosen, then “price” has to be positive value that you would like to BUY or SELL at. If STOP is chosen, then “stopPrice” has to be positive value that you would like to BUY or SELL at. If STOP_LIMIT is chosen, then “price” and “stopPrice” should be non-zero. |
| orderSubType | string Default: "REGULAR" Enum: "REGULAR" "FRACTIONAL" "MONEY_ORDER" Order sub-type. REGULAR: If you would like to BUY/SELL an INTEGER order quantity, then this should be set. Then you should set orderQty. FRACTIONAL: If you would like to BUY/SELL a NON-INTEGER order quantity, then this should be set. Then you should set orderQty. orderType can only be 'MARKET' MONEY_ORDER: If you DO NOT want to specify order quantity, BUT you WANT to BUY/SELL based on specified money amount. Then you should set orderAmount. orderType can only be 'MARKET' |
| blockOrderType | string Default: "NONE" Enum: "NONE" "SINGLE" "BLOCK" If this order is a block order, then set SINGLE for child orders. If not a block order, set NONE |
| cutOffDate | string <YYYY-MM-DD> [ 0 .. 10 ] characters If this order is a block order, the actual date when the order will be sent to market. NOTE: This should be local date for TradeProvider. NOTE: If this is empty or null for a Block Order, this will be automatically earliest working date of market. |
| cutOffTime | string <hh:mm> [ 0 .. 5 ] characters If this order is a block order, it MUST be one of the TradeProvider's cutOffTimes provided from the /tradeProvider endpoint. NOTE: This is local time for TradeProvider. NOTE: If this is empty or null for a Block Order, this will be automatically earliest working time of market. |
| clientOrderId required | string [ 1 .. 50 ] characters A unique identifier string of the order as assigned by caller of the API. Uniqueness must be guaranteed within your software. |
| clientOrderLinkId | string [ 0 .. 50 ] characters An identifier string of the order as assigned by caller of the API. An id for which if you want to link a group of clientOrderId s in your own software. Trader OMS API does not operate on this. Permits order originators to tie together groups of orders in which trades resulting from orders are associated for a specific purpose, for example the calculation of average execution price for a customer or to associate lists submitted to a broker as waves of a larger program trade. |
| clientId required | string <uuid> [ 0 .. 36 ] characters Identifier UUID formatted string of the client for which the trading is done. If your API is an On-Premise deployment and your software uses the API in a server-to-server scenario, then, the API calling user is a Tenant user and has tenant_admin or api_user role. In this case, this is REQUIRED. If your API is a Main deployment and your software uses the API in a client-to-server scenario, and, the API calling user is a Business client user and has client_admin or client_brokerage_desk or api_user role. and the user wants to make a trade for its own client, in this case, this is REQUIRED. Otherwise, this should not be set. |
| side required | string Enum: "BUY" "SELL" "BUYMINUS" "SELLPLUS" "SELLSHORT" "SELLSHORTEXEMPT" "UNDISCLOSED" "CROSS" "CROSSSHORT" "CROSSSHORTEXEMPT" "ASDEFINED" "OPPOSITE" Order side. Only 'BUY', 'SELL' supported. |
| isinCode required | string = 12 characters ISIN of the financial instrument to be traded. |
| orderAmount required | number <decimal(14, 2)> Used if orderSubType is "MONEY_ORDER" only. Set Zero otherwise.Contains total money amount of desired investment. The orderQty is calculated within the API based on the market price. |
| orderQty required | number <decimal(14, 2)> Trade volume / quantity.Used if orderSubType is "REGULAR" or "FRACTIONAL" only. Set Zero otherwise. The orderQty is calculated within the API based on the market price. |
| currencyCode required | string Currency code, such as "EUR" |
| price | number <decimal(14, 2)> Price per unit of quantity, mandatory value when orderType is one of "LIMIT" or "STOP_LIMIT". Set as default 0.0 otherwise |
| stopPrice | number <decimal(14, 2)> Stop price per unit of quantity, mandatory value when orderType is one of "STOP" or "STOP_LIMIT". Set as default 0.0 otherwise |
| comment | string [ 0 .. 64 ] characters String comment/note for your reference. |
| timeInForce required | string Enum: "DAY" "GOOD_TILL_CANCEL" "IMMEDIATE_OR_CANCEL" "FILL_OR_KILL" "GOOD_TILL_DATE" It specifies a time frame for the order to be valid. Only IMMEDIATE_OR_CANCEL, FILL_OR_KILL, GOOD_TILL_DATE supported. IMMEDIATE_OR_CANCEL: The order is valid until if it can be FILLED within a few seconds. Then it will be CANCELED by the market and will not be processed. FILL_OR_KILL: The order is valid until it can be FILLED fully. If not, it will be CANCELED by the market and will not be processed. GOOD_TILL_DATE: The order is valid until the day you specified in expireDate. |
| expireDate | string <YYYYMMDD> = 10 characters Date of order expiration (the local market date at which the order can be traded last). For non-Block Orders, must always be given (independent of timeInForce). For Block Orders, this is not required and filled with cutOffDate value. |
| internalAccountId | string <uuid> The internal account the trade will happen. If null, then default internal account is used. Is there is no default set, you will get error response. |
| depositAccountId | string <uuid> The deposit account the trade will happen. If null, then default deposit account is used. Is there is no default set, you will get error response. |
| provider required | string Default: "ICF" Enum: "ICF" "AllFunds" "TickTS" "Unknown" It is the market which an order is placed. |
| algorithmIdentifier | string <([A-Z]|[0-9]){1,50}> [ 0 .. 50 ] characters If this order is generated by an automated trading algorithm of a client then this field should be set to NON-NULL. If not by an algorithm, provide null. Format is ESMA_AlphaNumericCapitalLettersMax50_Pattern which is defined as follows: (ie: Max 50, English capital letters A-Z and numbers 0-9); |
| investmentDecisionMakerId | string <uuid> = 36 characters Identifier UUID of decision maker for business clients. |
| executingTraderId | string <uuid> = 36 characters Identifier UUID of executing trader. |
| calculateMetrics | boolean Default: false Boolean flag to calculate metrics.If it is true,oms and sdm duration metrics will be calculated and return in the response |
Responses
Request samples
- Payload
{- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "blockOrderType": "NONE",
- "cutOffDate": "2023-05-16",
- "cutOffTime": "13:45",
- "clientOrderId": "MY-APP-clientId-a-uniqueId",
- "clientOrderLinkId": "MY-APP-clientId-groupId-a-uniqueId",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "orderAmount": 350,
- "orderQty": 2,
- "currencyCode": "EUR",
- "price": 12.75,
- "stopPrice": 12.65,
- "comment": "Tech instrument buy, based on aggressive strategy",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "internalAccountId": "80dff914-a914-4953-ba3e-9ab23d234843",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "provider": "ICF",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "executingTraderId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "calculateMetrics": true
}Response samples
- 200
{- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "provider": "ICF",
- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "clientOrderLinkId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "actualClientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountNumber": "0000000011",
- "actualClientInternalAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientInternalAccountNumber": "0000000333",
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "marketMakerId": "XQTX",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "currencyCode": "EUR",
- "price": 12.75,
- "stopPrice": 12.65,
- "orderQty": 2,
- "orderAmount": 350,
- "comment": 12.65,
- "orderStatus": "PENDING_NEW",
- "transactTime": "2023-01-28T13:58:43Z",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "estimatedSlippage": 0.25,
- "estimatedSlippageInfo": "%1 OF TOTAL",
- "initialQty": 0,
- "marketQty": 0,
- "filledQty": 0,
- "leavesQty": 0,
- "averagePrice": 12.75,
- "estimatedMaxTotalPrice": 0.25,
- "estimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaCashAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "peaPositionId": "777a23e7-8aef-4718-a709-c609f114e031",
- "peaQty": 0,
- "peaEstimatedMaxTotalPrice": 0.25,
- "peaEstimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaEstimatedSlippage": 0.25,
- "peaEstimatedSlippageInfo": "%1 OF TOTAL",
- "totalCommission": 3.25,
- "totalCommissionInfo": "ExecutionId: b94c32fa-af33-4ee2-a9cb-0f8738eb5671. Total: (12.3400 + 3.2500)",
- "executionCount": 3,
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "internalAccountId": "80dff914-a914-4953-ba3e-9ab23d234843",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "blockOrderType": "NONE",
- "cutOffDate": "2023-05-16",
- "cutOffTime": "13:45",
- "blockOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "tradeCounterParty": "ICF",
- "hasBlocakage": true,
- "blockageAmount": 200,
- "availableFloatingBalance": 200,
- "usedFloatingBalance": 200,
- "floatingBalanceLastUsedDate": "2023-01-28T13:58:43Z",
- "wmDataGD496HValue": 7,
- "tradeSlippageRiskFactor": 2,
- "defaultSlippageRatio": 0.5,
- "marketOrderBuyingPowerThreshold": 0.5,
- "tickSize": 0.01,
- "estimatedNAVDate": "2024-05-05",
- "peaDepositAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient",
- "orderMetrics": {
- "totalOMSTime": 100,
- "totalSDMTime": 100,
- "sdmQueueTime": 100
}
}Get order cost estimation
An optional service, which is used for getting approximate commission, tax costs for the specified order parameters.
Authorizations:
query Parameters
| clientId required | string Example: clientId=9f8f5989-04d7-47bc-bf6b-4043998b51ee The unique identifier of the client in UUID string format of 36 chars length. |
| orderType required | string Enum: "MARKET" "LIMIT" "STOP" "STOP_LIMIT" "PREVIOUSLY_QUOTED" Example: orderType=MARKET Order type |
| orderSubType required | string Enum: "REGULAR" "FRACTIONAL" "MONEY_ORDER" Example: orderSubType=REGULAR Order sub type |
| orderSide required | string Enum: "BUY" "SELL" "BUYMINUS" "SELLPLUS" "SELLSHORT" "SELLSHORTEXEMPT" "UNDISCLOSED" "CROSS" "CROSSSHORT" "CROSSSHORTEXEMPT" "ASDEFINED" "OPPOSITE" Example: orderSide=BUY Order side. Only 'BUY', 'SELL' supported. |
| isinCode required | string Example: isinCode=AT0000609607 ISIN of the financial instrument to be traded. |
| instrumentType required | string Example: instrumentType=Stocks Financial instrument type. One of "Stocks", "Warrants", "Bonds", "Fonds", "EtfOrEtc", "Index" |
| tradeSourcePlatform required | string Enum: "FIX_CLIENT" "REST_API" "MOBILE" "ADJUSTMENT" Example: tradeSourcePlatform=REST_API Platform from which create order is going to be placed. REST_API in this case. |
| tradeProvider required | string Enum: "ICF" "AllFunds" "TickTS" "Unknown" Example: tradeProvider=ICF Trading provider or market provider where the create order is going to be placed. |
| price | number Example: price=12.75 Price per unit of quantity, mandatory value when orderType is one of "LIMIT" or "STOP_LIMIT". Set as default 0.0 otherwise. Default: 0.0 |
| stopPrice | number Example: stopPrice=12.65 Stop price per unit of quantity, mandatory value when orderType is one of "STOP" or "STOP_LIMIT". Set as default 0.0 otherwise. Default: 0.0 |
| quantity | number Example: quantity=2 Trade volume / quantity.Used if orderSubType is "REGULAR" or "FRACTIONAL" only. Set Zero otherwise. The orderQty is calculated within the API based on the market price. |
| orderAmount | number Example: orderAmount=350 Used if orderSubType is "MONEY_ORDER" only. Set Zero otherwise.Contains total money amount of desired investment. The orderQty is calculated within the API based on the market price. Default: 0.0 |
Responses
Response samples
- 200
{- "feeCalculationResult": {
- "code": "Unknown",
- "commission": 3.25,
- "comissionRatioToVolume": 1,
- "commissionInfo": "Commission: 3.25. Commission %: 1.00",
- "totalCommissionInfo": "Commission: 3.25. Commission %: 1.00",
- "estimatedSlippage": 0.25,
- "estimatedSlippageInfo": "%1 OF TOTAL",
- "estimatedMaxTotalPrice": 0.25,
- "estimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "errorMessage": "FeeDefinition is not defined for this order type and instrument type."
}, - "estimatedNAVDate": "2024-03-24"
}Get all open positions of a client
Get all open positions of a client in a paged manner. If deposit account id is provided as a parameter, it will return the positions of the client within the given deposit account.
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
query Parameters
| depositAccountId | string Example: depositAccountId=0112cbf8-dfec-4edf-917b-08dae1b865b3 Deposit account id in uuid string format. If you want to get positions within a deposit account. |
| pageNumber | string Example: pageNumber=1 In paged result, what is the page number to request |
| recordsPerPage | string <= 1000 Example: recordsPerPage=100 In paged result, how many items to be in the result at max. Maximum value is 1000. |
Responses
Response samples
- 200
{- "pageNumber": 1,
- "recordsPerPage": 10,
- "totalRecordCount": 120,
- "isLastPage": false,
- "data": [
- {
- "id": "824e433e-e26d-49c8-9350-5a66f6751f96",
- "provider": "ICF",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "type": "BUY",
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "currencyCode": "EUR",
- "priceAtLastExecution": 12.75,
- "priceAverage": 12.75,
- "profit": 12.75,
- "quantity": 3,
- "blockedQuantity": 1,
- "blockageDate": "2023-01-28T13:58:43Z",
- "blockageUser": "5c3c8ad9-0ece-4c6a-98b4-cfd51e1f1bf3",
- "quantityAwaitingSellOrder": 0,
- "lastBidPriceAtProfitCalculation": 0
}
]
}Get open trade orders of the client
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
query Parameters
| pageNumber | string Example: pageNumber=1 In paged result, what is the page number to request |
| recordsPerPage | string <= 1000 Example: recordsPerPage=100 In paged result, how many items to be in the result at max. Maximum value is 1000. |
Responses
Response samples
- 200
{- "pageNumber": 1,
- "recordsPerPage": 10,
- "totalRecordCount": 120,
- "isLastPage": false,
- "data": [
- {
- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "provider": "ICF",
- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "clientOrderLinkId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "actualClientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountNumber": "0000000011",
- "actualClientInternalAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientInternalAccountNumber": "0000000333",
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "marketMakerId": "XQTX",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "currencyCode": "EUR",
- "price": 12.75,
- "stopPrice": 12.65,
- "orderQty": 2,
- "orderAmount": 350,
- "comment": 12.65,
- "orderStatus": "PENDING_NEW",
- "transactTime": "2023-01-28T13:58:43Z",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "estimatedSlippage": 0.25,
- "estimatedSlippageInfo": "%1 OF TOTAL",
- "initialQty": 0,
- "marketQty": 0,
- "filledQty": 0,
- "leavesQty": 0,
- "averagePrice": 12.75,
- "estimatedMaxTotalPrice": 0.25,
- "estimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaCashAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "peaPositionId": "777a23e7-8aef-4718-a709-c609f114e031",
- "peaQty": 0,
- "peaEstimatedMaxTotalPrice": 0.25,
- "peaEstimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaEstimatedSlippage": 0.25,
- "peaEstimatedSlippageInfo": "%1 OF TOTAL",
- "totalCommission": 3.25,
- "totalCommissionInfo": "ExecutionId: b94c32fa-af33-4ee2-a9cb-0f8738eb5671. Total: (12.3400 + 3.2500)",
- "executionCount": 3,
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "internalAccountId": "80dff914-a914-4953-ba3e-9ab23d234843",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "blockOrderType": "NONE",
- "cutOffDate": "2023-05-16",
- "cutOffTime": "13:45",
- "blockOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "tradeCounterParty": "ICF",
- "hasBlocakage": true,
- "blockageAmount": 200,
- "availableFloatingBalance": 200,
- "usedFloatingBalance": 200,
- "floatingBalanceLastUsedDate": "2023-01-28T13:58:43Z",
- "wmDataGD496HValue": 7,
- "tradeSlippageRiskFactor": 2,
- "defaultSlippageRatio": 0.5,
- "marketOrderBuyingPowerThreshold": 0.5,
- "tickSize": 0.01,
- "estimatedNAVDate": "2024-05-05",
- "peaDepositAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient",
- "orderMetrics": {
- "totalOMSTime": 100,
- "totalSDMTime": 100,
- "sdmQueueTime": 100
}
}
]
}Get a particular trade order of a client using clientOrderId
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
| clientOrderId required | string Example: E875AF11-0E88-4C10-E82C-08DA0CC76151 Order Id |
Responses
Response samples
- 200
{- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "provider": "ICF",
- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "clientOrderLinkId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "actualClientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountNumber": "0000000011",
- "actualClientInternalAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientInternalAccountNumber": "0000000333",
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "marketMakerId": "XQTX",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "currencyCode": "EUR",
- "price": 12.75,
- "stopPrice": 12.65,
- "orderQty": 2,
- "orderAmount": 350,
- "comment": 12.65,
- "orderStatus": "PENDING_NEW",
- "transactTime": "2023-01-28T13:58:43Z",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "estimatedSlippage": 0.25,
- "estimatedSlippageInfo": "%1 OF TOTAL",
- "initialQty": 0,
- "marketQty": 0,
- "filledQty": 0,
- "leavesQty": 0,
- "averagePrice": 12.75,
- "estimatedMaxTotalPrice": 0.25,
- "estimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaCashAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "peaPositionId": "777a23e7-8aef-4718-a709-c609f114e031",
- "peaQty": 0,
- "peaEstimatedMaxTotalPrice": 0.25,
- "peaEstimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaEstimatedSlippage": 0.25,
- "peaEstimatedSlippageInfo": "%1 OF TOTAL",
- "totalCommission": 3.25,
- "totalCommissionInfo": "ExecutionId: b94c32fa-af33-4ee2-a9cb-0f8738eb5671. Total: (12.3400 + 3.2500)",
- "executionCount": 3,
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "internalAccountId": "80dff914-a914-4953-ba3e-9ab23d234843",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "blockOrderType": "NONE",
- "cutOffDate": "2023-05-16",
- "cutOffTime": "13:45",
- "blockOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "tradeCounterParty": "ICF",
- "hasBlocakage": true,
- "blockageAmount": 200,
- "availableFloatingBalance": 200,
- "usedFloatingBalance": 200,
- "floatingBalanceLastUsedDate": "2023-01-28T13:58:43Z",
- "wmDataGD496HValue": 7,
- "tradeSlippageRiskFactor": 2,
- "defaultSlippageRatio": 0.5,
- "marketOrderBuyingPowerThreshold": 0.5,
- "tickSize": 0.01,
- "estimatedNAVDate": "2024-05-05",
- "peaDepositAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient",
- "orderMetrics": {
- "totalOMSTime": 100,
- "totalSDMTime": 100,
- "sdmQueueTime": 100
}
}Get trade executions of a trade order using clientOrderId
Get all executions of the given client using client order id.
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
| clientOrderId required | string Example: E875AF11-0E88-4C10-E82C-08DA0CC76151 Order Id |
query Parameters
| executionType | string Enum: "NEW" "PARTIAL_FILL" "FILL" "DONE_FOR_DAY" "CANCELED" "REPLACED" "PENDING_CANCEL" "STOPPED" "REJECTED" "SUSPENDED" "PENDING_NEW" "CALCULATED" "EXPIRED" "RESTATED" "PENDING_REPLACE" "TRADE" "TRADE_CORRECT" "TRADE_CANCEL" "ORDER_STATUS" "TRADE_IN_CLEARING_HOLD" "TRADE_HAS_BEEN_RELEASED_TO_CLEARING" "TRIGGERED_OR_ACTIVATED_BY_SYSTEM" Example: executionType=TRADE Trade execution type filter |
Responses
Response samples
- 200
[- {
- "id": "b94c32fa-af33-4ee2-a9cb-0f8738eb5671",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "internalOrderId": "a1a4701f-b4b0-4fd9-82d5-24a0b180d992",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "provider": "ICF",
- "executionId": "EXEC_ID_2023_01_24_843296",
- "executionReferenceId": "EXEC_ID_2023_01_24_843296",
- "executionType": "PENDING_NEW",
- "executionInstruction": "External Routing Not Allowed",
- "executionRestatementReason": 7,
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "orderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "secondaryOrderId": "19a7139e-7ec3-448a-47b8-08daf3e12538",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "side": "BUY",
- "transactTime": "2023-01-28T13:58:43Z",
- "orderType": "MARKET",
- "orderStatus": "PENDING_NEW",
- "orderQty": 2,
- "price": 12.75,
- "stopPrice": 12.65,
- "currencyCode": "EUR",
- "lastMarket": "string",
- "lastQty": 0.1,
- "lastPrice": 0.1,
- "leavesQty": 0.1,
- "cumQty": 0.1,
- "averagePrice": 12.75,
- "settlementType": "REGULAR",
- "settlementDate": 20230125,
- "settlementCurrencyAmount": 238.65,
- "settlementCurrency": "EUR",
- "settlementCurrencyFxRate": 1.0893,
- "settlementCurrencyFxRateCalculation": "MULTIPLY",
- "regulatoryTradeID_TVTIC": "TVTIC",
- "text": "some comment",
- "returnCodeProvider": 1,
- "orderRejectReason": 1,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "commission": 3.25,
- "commissionInfo": "Commission: 3.25. Commission %: 1.00",
- "slippage": 0.25,
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "mifirTransactionId": "cf002f71d22f41348fb6ef54ab9c0840yyyyMMddHHmmss",
- "mifirReportedFlag": true,
- "mifirReportedFlagUpdateDate": "2023-01-25",
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "decisionMakerShortCode": "dmuser1",
- "investmentDecisionMakerShortCode": "dmuser1",
- "tradingCapacity": 1,
- "contraFirmLEI": "string",
- "contraFirmMIC": "XQTX",
- "reversedUserId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "reversedDate": "2023-01-28T13:58:43Z"
}
]Get trade execution statement of a trade order using clientOrderId and executionId
Get execution statement of the given client using client order id and execution id.
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
| clientOrderId required | string Example: E875AF11-0E88-4C10-E82C-08DA0CC76151 Order Id |
| executionId required | string Example: F375BF18-0E00-9C10-E83C-08DA0CC76153 Execution Id |
Responses
Response samples
- 200
{- "createdDate": "2019-08-24T14:15:22Z",
- "executionDate": "2019-08-24T14:15:22Z",
- "contentType": "Unknown",
- "data": "string"
}Get all trade orders of the client
Get all trade orders of a client in a paged manner.
Authorizations:
path Parameters
| clientId required | string Example: D49A62B1-4F0A-4419-A282-032AC0B6A371 Client Id |
query Parameters
| isinCode | string Example: isinCode=AT0000609607 ISIN 12 characters of financial instrument. If provided, positions with given ISIN will be retrieved. |
| dateBegin | string Example: dateBegin=2023-01-23T23:59:59Z For filtering based on closing date of the position. Positon's closing date should be further date than this date. |
| dateEnd | string Example: dateEnd=2023-01-23T23:59:59Z For filtering based on closing date of the position. Positon's closing date should be earlier date than this date. |
| statusList | Array of strings Items Enum: "WAITING_SEND_CREATE_MSG" "WAITING_SEND_CANCEL_MSG" "WAITING_SEND_MODIFY_MSG" "PENDING_PARTIAL_FILL" "PENDING_FILL" "NEW" "PARTIALLY_FILLED" "FILLED" "CANCELED" "PENDING_CANCEL" "DELETED" "REJECTED" "SUSPENDED" "PENDING_NEW" "WAITING_FOR_EVENT" "EXPIRED" "PENDING_REPLACE" Example: statusList=NEW&statusList=PENDING_NEW For filtering based on status of the order. Array of OrderStatus strings in JSON |
| sideList | Array of strings Items Enum: "BUY" "SELL" "BUYMINUS" "SELLPLUS" "SELLSHORT" "SELLSHORTEXEMPT" "UNDISCLOSED" "CROSS" "CROSSSHORT" "CROSSSHORTEXEMPT" "ASDEFINED" "OPPOSITE" Example: sideList=BUY For filtering based on side of the order. Array of OrderSide strings in JSON |
| orderTypeList | Array of strings Items Enum: "MARKET" "LIMIT" "STOP" "STOP_LIMIT" "PREVIOUSLY_QUOTED" Example: orderTypeList=MARKET For filtering based on type of the order. Array of OrderType strings in JSON |
| orderSubTypeList | Array of strings Items Enum: "REGULAR" "FRACTIONAL" "MONEY_ORDER" Example: orderSubTypeList=REGULAR For filtering based on subtype of the order. Array of OrderSubType strings in JSON |
| orderId | string Example: orderId=D49A62B1-4F0A-4419-A282-032AC0B6A371 For filtering orders using order id. |
| clientOrderId | string Example: clientOrderId=RV-123456 For filtering orders using client order id. |
| pageNumber | string Example: pageNumber=1 In paged result, what is the page number to request |
| recordsPerPage | string <= 1000 Example: recordsPerPage=100 In paged result, how many items to be in the result at max. Maximum value is 1000. |
Responses
Response samples
- 200
{- "pageNumber": 1,
- "recordsPerPage": 10,
- "totalRecordCount": 120,
- "isLastPage": false,
- "data": [
- {
- "id": "6d91ef9c-f889-4d9a-9acb-30f08f1c84d7",
- "positionId": "ffe2efb6-cb58-4543-a23a-a19cde137c5e",
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "clientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "cpCode": "CP0001",
- "provider": "ICF",
- "orderType": "MARKET",
- "orderSubType": "MONEY_ORDER",
- "sourcePlatform": "REST_API",
- "apiUserId": "cf002f71-d22f-4134-8fb6-ef54ab9c0840",
- "clientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "originalClientOrderId": "MY-OMS-CLIENT-clientId-timestamp",
- "clientOrderLinkId": "MY-OMS-CLIENT-clientId-timestamp",
- "marketAccountId": "BUY",
- "actualClientId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientDepositAccountNumber": "0000000011",
- "actualClientInternalAccountId": "9f8f5989-04d7-47bc-bf6b-4043998b51ee",
- "actualClientInternalAccountNumber": "0000000333",
- "exDestination": "XQTX",
- "exDestinationIDSource": "MIC",
- "marketMakerId": "XQTX",
- "side": "BUY",
- "isinCode": "AT0000609607",
- "shortCode": "TSL",
- "instrumentName": "Tesla Inc.",
- "instrumentType": "Stocks",
- "currencyCode": "EUR",
- "price": 12.75,
- "stopPrice": 12.65,
- "orderQty": 2,
- "orderAmount": 350,
- "comment": 12.65,
- "orderStatus": "PENDING_NEW",
- "transactTime": "2023-01-28T13:58:43Z",
- "timeInForce": "FILL_OR_KILL",
- "expireDate": 20230128,
- "createdDate": "2023-01-28T13:58:43Z",
- "updatedDate": "2023-01-28T13:58:43Z",
- "estimatedSlippage": 0.25,
- "estimatedSlippageInfo": "%1 OF TOTAL",
- "initialQty": 0,
- "marketQty": 0,
- "filledQty": 0,
- "leavesQty": 0,
- "averagePrice": 12.75,
- "estimatedMaxTotalPrice": 0.25,
- "estimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaCashAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "peaPositionId": "777a23e7-8aef-4718-a709-c609f114e031",
- "peaQty": 0,
- "peaEstimatedMaxTotalPrice": 0.25,
- "peaEstimatedMaxTotalPriceInfo": "ORDER_QTY x STOP_PRICE + ESTIMATED_SLIPPAGE",
- "peaEstimatedSlippage": 0.25,
- "peaEstimatedSlippageInfo": "%1 OF TOTAL",
- "totalCommission": 3.25,
- "totalCommissionInfo": "ExecutionId: b94c32fa-af33-4ee2-a9cb-0f8738eb5671. Total: (12.3400 + 3.2500)",
- "executionCount": 3,
- "operatingMic": "XDUS",
- "segmentMic": "XQTX",
- "internalAccountId": "80dff914-a914-4953-ba3e-9ab23d234843",
- "depositAccountId": "9fe29031-47ea-4681-b97a-80aa2dc3bcd7",
- "returnCode": 0,
- "returnCodeSource": "API",
- "returnCodeText": "string",
- "blockOrderType": "NONE",
- "cutOffDate": "2023-05-16",
- "cutOffTime": "13:45",
- "blockOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "providerOrderId": "85f09b03-ede6-4674-a5a3-ecb0f67bae77",
- "tradeCounterParty": "ICF",
- "hasBlocakage": true,
- "blockageAmount": 200,
- "availableFloatingBalance": 200,
- "usedFloatingBalance": 200,
- "floatingBalanceLastUsedDate": "2023-01-28T13:58:43Z",
- "wmDataGD496HValue": 7,
- "tradeSlippageRiskFactor": 2,
- "defaultSlippageRatio": 0.5,
- "marketOrderBuyingPowerThreshold": 0.5,
- "tickSize": 0.01,
- "estimatedNAVDate": "2024-05-05",
- "peaDepositAccountId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "algorithmIdentifier": "AGGRESSIVEBUYWHENCRITERIAXV12",
- "clientIdentificationCode": "string",
- "clientIdentificationCodeType": "NaturalPerson",
- "investmentDecisionMakerId": "e0cd7b5c-42dd-4364-a4c2-b5fc4fb79a72",
- "investmentDecisionMaker": "string",
- "investmentDecisionMakerCodeType": "NaturalPerson",
- "investmentDecisionMakerScope": "RetailClient",
- "executingTraderId": "1d9b345f-a540-47bf-8bf8-4b0b85bbe1e5",
- "executingTrader": "string",
- "executingTraderType": "NaturalPerson",
- "executingTraderScope": "RetailClient",
- "orderMetrics": {
- "totalOMSTime": 100,
- "totalSDMTime": 100,
- "sdmQueueTime": 100
}
}
]
}Finds and returns the earliest CutOffDate and CutOffTime which the market is working.
Authorizations:
path Parameters
| tradeProvider required | string Enum: "ICF" "AllFunds" "TickTS" "Unknown" Example: ICF TradeProvider |
Responses
Response samples
- 200
{- "mic": "DUSC",
- "timeZone": "Europe/Berlin",
- "date": "2023-05-16",
- "time": "13:45"
}Get your Tenant's CutOffTimes for BlockOrders for the given TradeProvider
Authorizations:
path Parameters
| tradeProvider required | string Enum: "ICF" "AllFunds" "TickTS" "Unknown" Example: ICF TradeProvider |
Responses
Response samples
- 200
[- {
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "tradeProvider": "ICF",
- "cutOffTime": "14:50",
- "timeZone": "Europe/Berlin",
- "createdDate": "2023-01-28T13:58:43Z",
- "createdUserId": "ea883679-0764-42eb-b13d-d42144f85b0f"
}
]Get your Tenant's CutOffTimes for BlockOrders based on TradeProvider
Authorizations:
Responses
Response samples
- 200
[- {
- "tenantId": "ea883679-0764-42eb-b13d-d42144f85b0f",
- "tradeProvider": "ICF",
- "cutOffTime": "14:50",
- "timeZone": "Europe/Berlin",
- "createdDate": "2023-01-28T13:58:43Z",
- "createdUserId": "ea883679-0764-42eb-b13d-d42144f85b0f"
}
]